/** Rill v0.0.458 https://www.npmjs.com/package/rill License: MIT*/
var callbacks, event, handleChange, handleClick, hijack, ref;

event = require("component-event");

callbacks = [];

hijack = module.exports = {
  listen: function(element) {
    if (element == null) {
      element = window;
    }
    event.bind(element, "load", handleChange);
    event.bind(element, "popstate", handleChange);
    event.bind(element, "submit", handleClick);
    event.bind(element, "click", handleClick);
    return hijack;
  },
  createServer: function(cb) {
    callbacks.push(cb);
    return hijack;
  },
  goTo: function(url, arg) {
    var cb, headers, i, len, method, ref, replaceState, req, title;
    ref = arg != null ? arg : {}, method = ref.method, headers = ref.headers, title = ref.title, replaceState = ref.replaceState;
    if (title == null) {
      title = "";
    }
    req = {
      url: url,
      method: method != null ? method : "GET",
      headers: headers != null ? headers : {}
    };
    window.history[Boolean(replaceState) ? "replaceState" : "pushState"](url, title, url.href);
    for (i = 0, len = callbacks.length; i < len; i++) {
      cb = callbacks[i];
      cb(req);
    }
  }
};

ref = require("./handlers"), handleClick = ref.handleClick, handleChange = ref.handleChange;
